# FileOperationCompleteData

If a [script add-in](/directory-opus/manual/scripting/script_add-ins.md)implements the [**OnFileOperationComplete**](/directory-opus/manual/reference/scripting_reference/scripting_events/onfileoperationcomplete.md) event, the method receives a **FileOperationCompleteData** object whenever a supported file operation begins. If you return **True** to indicate that you want to be notified about the operation, you'll receive another call when the operation is complete.

| Property Name | Return Type                                                                                         | Description                                                                                                                                                                                                                                                                                                                                                                                                       |
| ------------- | --------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| action        | *string*                                                                                            | Returns a string that indicates the type of file operation. Currently the only supported value is **"rename"**.                                                                                                                                                                                                                                                                                                   |
| cmdline       | *string*                                                                                            | Returns a string that provides the entire command line that launched this operation.                                                                                                                                                                                                                                                                                                                              |
| data          | *variant*                                                                                           | <p>When the <strong>query</strong> property is <strong>False</strong> this provides further information about the operation that completed.<br>For "rename" this returns a <a href="/pages/MQevWUcoJQ2LRO5rlpkU"><strong>Map</strong></a> object that provides a map of all items that were renamed and their new names.</p>                                                                                      |
| dest          | *object:*[**Path**](/directory-opus/manual/reference/scripting_reference/scripting_objects/path.md) | Returns a [**Path**](/directory-opus/manual/reference/scripting_reference/scripting_objects/path.md) object representing the destination path of the operation.                                                                                                                                                                                                                                                   |
| qualifiers    | *string*                                                                                            | <p>Returns a string indicating any qualifier keys that were held down by the user when the operation was initiated.<br>The string can contain any or all of the following: <em>shift</em> <em>ctrl</em>, <em>alt</em>, <em>lwin</em>, <em>rwin</em><br>If no qualifiers were down, the string will be: <em>none</em></p>                                                                                          |
| query         | *bool*                                                                                              | Returns **True** the first time the [**OnFileOperationComplete**](/directory-opus/manual/reference/scripting_reference/scripting_events/onfileoperationcomplete.md) event is called. You should examine the action and other properties and return **True** if you decide you want notification about this operation. This will be **False** when you are called the second time, when the operation is complete. |
| source        | *object:*[**Path**](/directory-opus/manual/reference/scripting_reference/scripting_objects/path.md) | Returns a [**Path**](/directory-opus/manual/reference/scripting_reference/scripting_objects/path.md) object representing the source path of the operation.                                                                                                                                                                                                                                                        |
| tab           | *object:*[**Tab**](/directory-opus/manual/reference/scripting_reference/scripting_objects/tab.md)   | Returns a [**Tab**](/directory-opus/manual/reference/scripting_reference/scripting_objects/tab.md) object representing the source folder tab.                                                                                                                                                                                                                                                                     |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://chaoses-ib.gitbook.io/directory-opus/manual/reference/scripting_reference/scripting_objects/fileoperationcompletedata.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
